/*
    Fichier filtredest.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence.fr

    Traductions des droits d'utilisation dans les fichiers :
    licence.de , licence.en , licence.es , licence.it
    licence.nl , licence.pt , licence.eo , licence.eo-utf


    Ce programme dtruit les fichiers mail envoys  des
    destinataires particuliers.
    Il sert  filtrer les spams envoys  une adresse Email
    alphabtiquement voisines de l'adresse de celui qui reoit
    le mail.

    La liste des adresses de destinataires interdites est mmorise
    dans un fichier

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"
#include "testchamp.h"
#include "trtentete.h"
#include "szchemin.h"


#define nbmax_dest    500     // nombre max de destinataires interdits


/* prototypes */
int testdest (int numes);


/* variables globales au source
   (pour viter des tonnes de passages de paramtres) */

char *listedest [nbmax_dest]; // mmorise les destinataires interdits
int  sz_listedest;       // nombre de destinataires mmoriss dans listedest
char bufTo [80];         // buffer contenant le destinataire du mail
int  opto, optO;         // options de traitement


/* programme principal */

int main (int nbarg, char *varg[])
{
    // fichier contenant la liste des chaines  tester
    char fichliste [szchemin + 11];
    FILE *fconf;         // descripteur du fichier de configuration
    FILE *ftrace;        // fichier contenant les destinataires des mail refuss
    int  numes, nbmes;   // mumro du mail courant et nombre de mails
    char bufw [80];      // buffer d'envoi d'une requte de destruction de mail
    char datecour [10];  // date courante (pour le fichier des mails refuss)
    int  conserves = 0;  // nombre de mails conservs
    int  supprimes = 0;  // nombre de mails supprims
    char *ncom;          // nom de la commande que l'on excute (filtredest)


    // rcupration du nom de l'excutable
    ncom = varg [0];
    nbarg --;
    varg ++;

    // initialisations valeur des options
    ftrace = NULL;
    opto = 0;
    optO = 0;

    // si le programme a t lanc avec des options
    while (nbarg >= 2 && **varg == '-')
    {
        // traitement des options
        switch (varg [0][1])
        {
            // option trace des mails supprims
            case 't' : // ouvrir le fichier trace en criture fin de fichier
                       ftrace = fopen (varg [1], "a");

                       // si nom de fichier correct
                       if (ftrace)
                           // initialiser la date courante
                           initdatecour (datecour);
                       else
                           // sinon, avertir l'utilisateur
                           fprintf (stderr,
                    "Impossible d'crire dans le fichier %s\n", varg [1]);

                       // sauter les arguments traits
                       nbarg -= 2;
                       varg  += 2;
                       break;

            // option test de la ligne d'entte d'origine (avant conversion)
            case 'o' : if (! optO)
                           opto = 1;
                       else
                           fputs ("L'option -O est prioritaire sur l'option -o\n",
                                                                        stderr);

                       // sauter l'argument trait
                       nbarg --;
                       varg  ++;
                       break;

            // option test de la ligne d'entte d'origine (avant conversion)
            case 'O' : optO = 1;

                       if (opto)
                           fputs ("L'option -O est prioritaire sur l'option -o\n",
                                                                        stderr);

                       // sauter l'argument trait
                       nbarg --;
                       varg  ++;
                       break;

            // aucune autre option n'est reconnue
            default  : fprintf (stderr, "Option %s incorrecte\n", *varg);
                       nbarg = 0;  // pour rappeller la syntaxe
        }
    }

    // controle du nombre d'arguments restants
    if (nbarg == 1)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (*varg);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcuprer le nom du rpertoire racine de la messagerie
                fgets (fichliste, szchemin, fconf);

                // fabriquer le chemin d'accs au fichier
                // contenant les destinataires interdits
                strcpy (fichliste + strlen (fichliste) - 1, "/refus_dest");

                // charger en mmoire les destinataires interdits
                sz_listedest = charge_valchamp (fichliste, listedest,
                                                nbmax_dest, "nbmax_dest");

                // si la liste n'est pas vide
                if (sz_listedest)
                {
                    // rcupration du nombre de mails
                    nbmes = nbmails ();

                    // vrification des diffrents mails
                    for (numes = 1; numes <= nbmes; numes++)
                    {
                        // si le destinataire du mail contient une chaine interdite
                        if (testdest (numes))
                        {
                            // demande de destruction du mail
                            sprintf (bufw, "DELE %d", numes);
                            env_pop (bufw);
                            lire_pop ();
                            supprimes ++;

                            // si utilisation d'un fichier trace
                            if (ftrace)
                                // mmoriser le destinataire de ce mail
                                fprintf (ftrace, "%s%s\n", datecour, bufTo);
                        }
                        else
                            conserves ++;
                    }

                    // dition d'un rcapitulatif
                    printf ("\n%d messages conservs, %d supprims\n",
                                              conserves, supprimes);
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();

                // si des mails ont t supprims
                if (supprimes)
                    // attendre pour enregistrement correct des suppressions
                    // (vite problme si autre filtre appel juste aprs)
                    sleep (2);
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        fprintf (stderr,
     "Syntaxe : %s [-(o|O)] [-t fichier_trace] fich_configuration\n", ncom);

    return (0);
}



/* lit l'entte d'un mail et vrifie si son destinataire est autoris */

int testdest (int numes)
{
    char bufw [80];     // buffer d'envoi d'une requte
    char destbrut [80]; // buffer contenant le destinataire du mail non dcod
    int  debdest;       // position premier caractre utile du destinataire


    printf ("\rMessage %d", numes);
    fflush (stdout);

    // initialisation
    bufTo    [0] = '\0';
    destbrut [0] = '\0';

    // demande de lecture de l'entte du message
    sprintf (bufw, "TOP %d 1", numes);
    env_pop (bufw);

    // lecture entte du message et mmorisation du destinataire du mail
    do
    {
        // lire une ligne de l'entte du message
        lire_pop ();

        // si on a trouv le champ destinataire
        if (start ("To"))
        {
            // recherche du premier caractre significatif du destinataire
            debdest = 8;

            while (buf_lect [debdest] == ' ')
                debdest++;

            // si option -o ou -O
            if (opto || optO)
            {
                // mmoriser destinataire du mail avant conversion en le
                // tronquant si ncessaire pour viter un dbordement de tableau
                if (strlen (buf_lect + debdest) >= sizeof (destbrut))
                {
                    memcpy (destbrut, buf_lect + debdest, sizeof (destbrut));
                    destbrut [sizeof (destbrut) - 1] = '\0';
                }
                else
                    strcpy (destbrut, buf_lect + debdest);
            }

            // si on n'utilise pas l'option -O
            if (! optO)
            {
                // convertir les caractres spciaux de la ligne
                majlignentete ();

                // tronquer si ncessaire le destinataire
                if (strlen (buf_lect + debdest) >= sizeof (bufTo))
                     buf_lect [debdest + sizeof (bufTo) - 1] = '\0';

                // mmorisation du destinataire converti
                strcpy (bufTo, buf_lect + debdest);
            }
        }
    }
    // lecture termine si ligne limite  un .
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');

    // vrifier si le mail contient un des destinataires de la liste interdite
    if (optO)
        // option -O : test sur le destinataire brut seulement
        return trouve_valchamp (destbrut, listedest, sz_listedest);
    else if (opto)
    {
        // option -o (seule) : test sur le destinataire brut et converti
        return (trouve_valchamp (destbrut, listedest, sz_listedest)
            ||  trouve_valchamp (bufTo,    listedest, sz_listedest));
    }
    else
        // aucune option : test sur le destinataire converti seulement
        return trouve_valchamp (bufTo, listedest, sz_listedest);
}
