/*
    Fichier selhtm.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence.fr

    Traductions des droits d'utilisation dans les fichiers :
    licence.de , licence.en , licence.es , licence.it
    licence.nl , licence.pt , licence.eo , licence.eo-utf


    Ce programme recopie les caractristique de chaque mail
    en attente de tlchargement (ou de destruction).
    Ces informations sont mmorises dans 2 fichiers distincts,
    un pour les message lisibles en mode texte, l'autre pour les
    mais rdig seulement en HTML pur (frquent pour les publicits).

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"
#include "trtentete.h"


/* prototypes */
void lirentete (int numes);


/* variables globales au source
   (pour viter des tonnes de passages de paramtres) */

FILE *fseltxt, *fselhtm;    // descripteurs des 2 fichiers rsultat


/* programme principal */

int main (int nbarg, char *varg[])
{
    FILE *fconf;        // descripteur du fichier de configuration
    int  numes, nbmes;  // numro du mail courant et nombre de mails


    if (--nbarg == 3)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (varg [1]);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // ouvrir les fichiers rsultat
                fseltxt = fopen (varg [2], "w");
                fselhtm = fopen (varg [3], "w");

                if (fseltxt && fselhtm)
                {
                    // rcupration du nombre de mails
                    nbmes = nbmails ();

                    // rcupration de la liste des mails
                    for (numes = 1; numes <= nbmes; numes++)
                        lirentete (numes);

                    // pour l'affichage propre
                    putchar ('\n');
                }
                else
                    fputs ("Impossible d'crire dans un fichier rsultat\n",
                           stderr);

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        fprintf (stderr,
     "Syntaxe : %s  fich_configuration  fich_liste1  fich_liste2\n", varg [0]);

    return (0);
}


/* lit l'entte d'un message et affiche certaines lignes */

void lirentete (int numes)
{
    char bufw [80];  // buffer d'envoi d'une requte
    // buffers pour affichage ordonn des caractristiques du message
    char bufDate [80], bufFrom [80], bufTo [80], bufCc [80], bufReply [80],
         bufSubject [80], bufContent [80], bufRetPath [80];
    int  posbuf;     // simple compteur
    FILE *ficdest;   // descripteur du fichier qui mmorisera le message


    // initialisation
    bufDate [0]    = '\0';
    bufFrom [0]    = '\0';
    bufTo [0]      = '\0';
    bufCc [0]      = '\0';
    bufReply [0]   = '\0';
    bufSubject [0] = '\0';
    bufContent [0] = '\0';
    bufRetPath [0] = '\0';

    /* demande de lecture de l'entte du message
       On demande 5 lignes du corps du message pour trouver le
       2me Content-type si le premier est multipart/mixed */
    sprintf (bufw, "TOP %d 5", numes);
    env_pop (bufw);

    // suivi de l'excution
    printf ("\rMessage %d", numes);
    fflush (stdout);

    // lecture et mmorisation des caractristiques du message
    do
    {
        // lire une ligne de l'entte du message
        lire_pop ();

        // mmorisation des caractristiques importantes
        if (start ("Date"))
            membuf (bufDate);
        else if (start ("From"))
            memconvbuf (bufFrom);
        else if (start ("To"))
            memconvbuf (bufTo);
        else if (start ("Cc"))
            memconvbuf (bufCc);
        else if (start ("Reply-To"))
            memconvbuf (bufReply);
        else if (start ("Subject"))
            memconvbuf (bufSubject);
        else if (start ("Content-Type"))
            membuf (bufContent);
        else if (start ("Return-Path"))
            membuf (bufRetPath);
    }
    // lecture termine si ligne limite  un .
    while (buf_lect [0] != '.' && buf_lect [1] != '\r');

    // positionnement sur le 2me attribut de Content_type
    // ncessaire pour bonne dtection s'il y  0 ou plus
    // d'un blanc aprs le : du Content-Type
    posbuf = 17;

    while (bufContent [posbuf] != '/')
        posbuf++;

    // choix du fichier de destination
    if (*bufContent && tolower (bufContent [posbuf+1]) == 'h'
                    && tolower (bufContent [posbuf+2]) == 't')
        ficdest = fselhtm;
    else
        ficdest = fseltxt;

    fprintf (ficdest, "\nMessage %d\n", numes);

    // enregistrement des caractristiques mmorises
    if (bufDate [0])
        fprintf (ficdest, "%s\n", bufDate);
    if (bufFrom [0])
        fprintf (ficdest, "%s\n", bufFrom);
    if (bufTo [0])
        fprintf (ficdest, "%s\n", bufTo);
    if (bufCc [0])
        fprintf (ficdest, "%s\n", bufCc);
    if (bufReply [0])
        fprintf (ficdest, "%s\n", bufReply);
    if (bufRetPath [0])
        fprintf (ficdest, "%s\n", bufRetPath);
    if (bufSubject [0])
        fprintf (ficdest, "%s\n", bufSubject);
    if (bufContent [0])
        fprintf (ficdest, "%s\n", bufContent);
}
